
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1998][royale@ifrance.com]ͼ
                --  :*)

program cassbrik;
uses sourunit,crt;
const nb=2003;
      max_balls=10;
      max_tirs=10;
      max_options=10;
      col=38;
      scrn_pg=ptr($A000,0);
{$i police.inc}
{$i pcx.inc}

type ball_typ=record x,y,spe:real; ang,la,ha:byte; typ:byte; end;
     niv=record
	   nom:string[50];
           time:integer;
           freq:byte;
	   brik:array [0..15,1..19] of byte;
	 end;

var fond_pg,make_pg,brik_pg:pointer;   {pointeurs de pages virtuelles.}
    tcos,tsin:array [0..255] of real;
    tab:niv;
    balle:array [1..max_balls] of ball_typ;
    raquette:record x,y:word; taille,ha:byte; typ:byte; end;
    tir:array [1..max_tirs] of record x:word; y,spe:real; inplay:boolean; end;
    option:array [1..max_options] of record x:word; y,spe:real; la,ha,typ:byte; inplay:boolean; end;
    freq_options,effet,balls_left,life,cmpt:byte;
    i,j,niveau,image,nbimage,briks_left:word;
    time,nt,code:integer;
    ball_spe:real;
    debtime,score:longint;
    notime,son:boolean;
    cod,nom:string[8];
    fic:file of niv;
    fic2:file;
    s,t:string;
    cc:char;
    compt:byte;

procedure init_mode13;               {initialise le mode 13.}
begin
  getmem(fond_pg,64000);
  getmem(brik_pg,64000);
  getmem(make_pg,64000);
  asm
    mov ax,13h
    int 10h
  end;
end;

procedure close_mode13;              {ferme le mode 13 et les pointers.}
var i:word;
begin
  freemem(fond_pg,64000);
  freemem(brik_pg,64000);
  freemem(make_pg,64000);
  asm
    mov ax,03h
    int 10h
  end;
end;

procedure copypage(source,dest:pointer); assembler;
asm
  push ds
  les di,dest
  lds si,source
  mov cx,320*200/4
  db 66h;rep movsw
  pop ds
end;

procedure clearpage(page:pointer); assembler;
asm
  les di,page
  mov cx,320*200/4
  db 66h;xor ax,ax
  db 66h;rep stosw
end;

procedure copyblock(x,y:word; source:pointer; xs,ys:word; dest:pointer; xd,yd:word; mask:boolean); assembler;
asm
  push ds

  cmp x,0
  je @fin
  cmp y,0
  je @fin

  lds si,source
  les di,dest

  mov ax,yd
  shl ax,6
  add di,ax
  shl ax,2
  add di,ax
  add di,xd

  mov ax,ys
  shl ax,6
  add si,ax
  shl ax,2
  add si,ax
  add si,xs

  mov bx,320
  sub bx,x                  {met dans bx le dcalage de fin de ligne.}
  mov cx,y                  {met dans le compteur cx la largeur y.}

  cmp mask,false            {si masque est faux, on saute  la sous-procedure}
  je @sprite                {putsprite...}

  @boucle:
    push cx
    mov cx,x
    mov dx,cx
    shr cx,2
    db 66h;rep movsw
    mov cx,dx
    and cx,3
    rep movsb
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @boucle
  jmp @fin

  @sprite:
    push cx
    mov cx,x
    @line:
      mov ah,ds:[si]
      or ah,ah
      je @noir
      mov es:[di],ah
      @noir:
      inc di
      inc si
      dec cx
    jnz @line
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @sprite

  @fin:
  pop ds
end;

function getpixel(x,y:word):byte; assembler;
asm
  les di,fond_pg
  mov ax,y
  shl ax,6
  mov di,ax
  shl ax,2
  add di,ax
  add di,x
  mov ax,es:[di]
end;

procedure Init_C;   {initialise une table ctab de cosinus et stab de sinus}
var i:integer;
begin
  for i:=0 to 255 do begin
    tcos[i]:=cos(i/128*pi);
    tsin[i]:=sin(i/128*pi);
  end;
end;

function jour:byte; assembler;
asm
  mov ah,2Ah
  int 21h
  xor ax,ax
  mov al,dl
end;

function mois:byte; assembler;
asm
  mov ah,2Ah
  int 21h
  xor ax,ax
  mov al,dh
end;

function an:word; assembler;
asm
  mov ah,2Ah
  int 21h
  mov ax,cx
end;

function secondes:byte; assembler;
asm
  mov ah,2Ch
  int 21h
  mov al,dh
end;

function minutes:byte; assembler;
asm
  mov ah,2Ch
  int 21h
  mov al,cl
end;

function heure:byte; assembler;
asm
  mov ah,2Ch
  int 21h
  mov al,ch
end;

function niv2cod(level:word):string;
var k,tmp:word;
begin
  tmp:=1;
  for k:=1 to level do tmp:=tmp*nb;
  for k:=1 to 4 do begin
    niv2cod[k]:=chr(tmp mod 26+65);
    tmp:=tmp div 26;
  end;
  niv2cod[0]:=chr(4);
end;

function cod2niv(cod:string):word;
var tmp,co,k:word;
begin
  co:=ord(cod[1])-65+(ord(cod[2])-65)*26+(ord(cod[3])-65)*676+(ord(cod[4])-65)*17576;
  tmp:=1;
  for k:=1 to 999 do begin
    tmp:=tmp*nb;
    if tmp=co then begin cod2niv:=k; exit; end;
  end;
  cod2niv:=0;
end;

procedure best_score;
type best=array [1..10] of record nom:string[8]; date:string[10]; niveau:word; score:longint; end;
var royale:best;
    fic:file of best;
begin
  {$i-}
  assign(fic,'cassbrik.top');
  reset(fic);
  {$i+}
  if ioresult=0 then read(fic,royale) else for i:=1 to 10 do with royale[i] do begin
    nom:='ROYALE';
    score:=0;
    niveau:=0;
    date:='17/01/1998';
  end;
  for i:=1 to 10 do if score>royale[i].score then begin
    for j:=10 downto i+1 do royale[j]:=royale[j-1];
    royale[i].nom:=nom;
    royale[i].score:=score;
    royale[i].niveau:=niveau;
    str(jour,royale[i].date);
    if jour<10 then royale[i].date:='0'+royale[i].date;
    str(mois,s);
    if mois<10 then s:='0'+s;
    royale[i].date:=royale[i].date+'/'+s;
    str(an,s);
    royale[i].date:=royale[i].date+'/'+s;
    i:=10;
  end;
  rewrite(fic);
  write(fic,royale);
  close(fic);
  clearpage(scrn_pg);
  outtextxy(scrn_pg,103,30,'TABLEAU DES SCORES.',col,false);
  for i:=1 to 10 do begin
    outtextxy(scrn_pg,24,i*10+60,royale[i].nom,col,false);
    str(royale[i].score,s);
    outtextxy(scrn_pg,72,i*10+60,' : '+s,col,false);
    str(royale[i].niveau,s);
    if royale[i].niveau<100 then s:='0'+s;
    if royale[i].niveau<10 then s:='0'+s;
    outtextxy(scrn_pg,138,i*10+60,'NIVEAU '+s,col,false);
    outtextxy(scrn_pg,210,i*10+60,'LE '+royale[i].date,col,false);
  end;
  repeat until souris_bout<>1;
  repeat until souris_bout=1;
  close_mode13;
  while keypressed do cc:=readkey;
  halt;
end;

procedure put_ball(x,y:word; typ:byte);
begin
  case typ of
    0:copyblock(5,5,brik_pg,0,160,make_pg,x,y,false);
    1:copyblock(7,7,brik_pg,5,160,make_pg,x,y,false);
    2:copyblock(9,9,brik_pg,12,160,make_pg,x,y,false);
  end;
end;

procedure put_brik(i,j:byte);
begin
  copyblock(20,10,fond_pg,i*20,j*10,make_pg,i*20,j*10,true);
  if tab.brik[i,j]<>0 then
    copyblock(20,10,brik_pg,((tab.brik[i,j]-1) mod 16)*20,(tab.brik[i,j]-1) div 16*10,make_pg,i*20,j*10,false);
end;

procedure pong;
begin
  if son then begin
    sound(4000);
    delay(5);
    nosound;
  end;
end;

procedure ding;
begin
  if son then begin
    sound(2000);
    delay(10);
    nosound;
  end;
end;

procedure presentation;
begin
  repeat until souris_bout<>1;
  for i:=1 to 13 do begin
    if souris_bout=1 then begin
      i:=13;
      repeat until souris_bout<>1;
    end;
    str(i,s);
    if i<100 then s:='0'+s;
    if i<10 then s:='0'+s;
    loadpcx('film\film.'+s,make_pg,0,255);
    copypage(make_pg,scrn_pg);
    delay(30);
  end;
  repeat until souris_bout=1;
  repeat until souris_bout<>1;
end;

{$i royale.inc}
{$i info.inc}

procedure init;
begin
  randomize;
  if not existe_souris then begin
    writeln('Need a mouse !');
    asm
      mov ah,02h
      mov dl,7
      int 21h
    end;
    halt;
  end;
  souris_en_xy(160,190);
  init_mode13;
  init_C;
  royale_presentation;
  clearpage(scrn_pg);
  presentation;
  clearpage(scrn_pg);
  info;
  clearpage(scrn_pg);
  loadpcx('briks.pcx',brik_pg,0,40);
  clearpage(fond_pg);
  clearpage(make_pg);
  while keypressed do cc:=readkey;
  nom:=saisir(100,72,'NOM ? ',col);
  s:=saisir(100,82,'PASSWORD ? ',col);
  niveau:=cod2niv(s);
  s:=saisir(100,92,'VITESSE (5) ? ',col);
  if s='' then ball_spe:=5 else val(s,ball_spe,code);
  s:=saisir(100,102,'EFFET (50) ? ',col);
  if s='' then effet:=50 else val(s,effet,code);
  s:=saisir(100,112,'SENSIBILITE (25) ? ',col);
  if s='' then i:=25 else val(s,i,code);
  sens_souris(i,i);
  s:=saisir(100,122,'SON (N) ? ',col);
  if s='O' then son:=true;
  {$i-}
  if niveau<>0 then begin
    str(niveau,s);
    if niveau<100 then s:='0'+s;
    if niveau<10 then s:='0'+s;
    assign(fic,'niveaux\niveau.'+s);
    reset(fic);
    if ioresult=0 then begin close(fic); dec(niveau); end else niveau:=0;
  end;
  repeat
    inc(nbimage);
    str(nbimage,s);
    if nbimage<100 then s:='0'+s;
    if nbimage<10 then s:='0'+s;
    assign(fic2,paramstr(1)+'\data.'+s);
    reset(fic2);
    close(fic2);
  until ioresult<>0;
  dec(nbimage);
  {$i+}
end;

procedure new_option(i,j:byte);
var k:byte;
begin
  if (freq_options<>0) and (random(freq_options)=0) then for k:=1 to max_options do with option[k] do if not inplay then begin
    inplay:=true;
    case random(100) of
      0..1:begin typ:= 0; la:=13; ha:= 6; end;
      2:begin typ:= 1; la:=13; ha:= 6; end;
      3..12:begin typ:= 2; la:=11; ha:= 5; end;
      13..22:begin typ:= 3; la:=11; ha:= 5; end;
      23..42:begin typ:= 4; la:= 5; ha:= 5; end;
      43..62:begin typ:= 5; la:= 5; ha:= 5; end;
      63..66:begin typ:= 6; la:= 9; ha:= 6; end;
      67..70:begin typ:= 7; la:= 9; ha:= 6; end;
      71..85:begin typ:= 8; la:=13; ha:= 6; end;
      86..93:begin typ:= 9; la:=13; ha:= 6; end;
      94..97:begin typ:=10; la:=13; ha:= 6; end;
      98..99:begin typ:=11; la:=13; ha:= 6; end;
    end;
    x:=i*20+10-la div 2;
    y:=j*10+5-ha div 2;
    spe:=ball_spe/2;
    k:=max_options;
  end;
end;

procedure break_brik(i,j:byte);
begin
  if (i in [0..15]) and (j in [1..19]) then begin
    case tab.brik[i,j] of
      1..3,8:begin inc(score,tab.brik[i,j]*10); tab.brik[i,j]:=0; dec(briks_left); new_option(i,j); end;
      5..7:inc(tab.brik[i,j]);
      9:begin balle[cmpt].spe:=balle[cmpt].spe*1.1; if balle[cmpt].spe>ball_spe*2 then balle[cmpt].spe:=ball_spe*2; end;
      10:begin balle[cmpt].spe:=balle[cmpt].spe*0.9; if balle[cmpt].spe<ball_spe/2 then balle[cmpt].spe:=ball_spe/2; end;
      11:begin
	tab.brik[i,j]:=0;
	dec(briks_left);
	break_brik(i-1,j-1);
	break_brik(i-1,j);
	break_brik(i-1,j+1);
	break_brik(i,j-1);
	break_brik(i,j+1);
	break_brik(i+1,j-1);
	break_brik(i+1,j);
	break_brik(i+1,j+1);
      end;
      12..21:begin inc(score,300); tab.brik[i,j]:=0; dec(briks_left); new_option(i,j); end;
    end;
    put_brik(i,j);
    if tab.brik[i,j]=0 then copyblock(20,10,fond_pg,i*20,j*10,make_pg,i*20,j*10,true);
  end;
end;

procedure move_ball(var kk:ball_typ);
var i,j:word;
begin
  with kk do begin
    i:=trunc(x+la div 2+tcos[ang]*spe) div 20;
    j:=trunc(y+ha div 2) div 10;
    if tab.brik[i,j]<>0 then begin
      break_brik(i,j);
      if typ<>2 then begin ang:=128-ang; pong; end
      else if tab.brik[i,j] in [4,9,10] then else pong;
    end;
    i:=trunc(x+la div 2) div 20;
    j:=trunc(y+ha div 2+tsin[ang]*spe) div 10;
    if tab.brik[i,j]<>0 then begin
      break_brik(i,j);
      if typ<>2 then begin ang:=-ang; pong; end
      else if tab.brik[i,j] in [4,9,10] then else pong;
    end;
    copyblock(la,ha,fond_pg,trunc(x),trunc(y),make_pg,trunc(x),trunc(y),true);
    put_brik(trunc(x) div 20,trunc(y) div 10);
    put_brik(trunc(x+la) div 20,trunc(y) div 10);
    put_brik(trunc(x) div 20,trunc(y+ha) div 10);
    put_brik(trunc(x+la) div 20,trunc(y+ha) div 10);
    x:=x+tcos[ang]*spe;
    y:=y+tsin[ang]*spe;
    if (x<-tcos[ang]*spe) then begin
      x:=-tcos[ang]*spe;
      ang:=128-ang;
      pong;
    end;
    if (x>319-la-tcos[ang]*spe) then begin
      x:=319-la-tcos[ang]*spe;
      ang:=128-ang;
      pong;
    end;
    if (y<10-tsin[ang]*spe) then begin
      y:=10-tsin[ang]*spe;
      ang:=-ang;
      pong;
    end;
    if (y>199-ha-tsin[ang]*spe) then begin
      dec(balls_left);
      for i:=cmpt to balls_left do balle[i]:=balle[i+1];
      exit;
    end;
    if (ang in [0..127]) and (x+la>=raquette.x) and (x<=raquette.x+raquette.taille)
    and (y<=raquette.y) and (y+ha+spe*tsin[ang]>=raquette.y) then
    begin
      ang:=-ang-trunc((raquette.x+raquette.taille div 2-x-la div 2)/raquette.taille*effet);
      if ang in [236..255,0..63] then ang:=236;
      if ang in [64..148] then ang:=148;
      pong;
    end;
  end;
end;

procedure move_raquette;
begin
  with raquette do begin
    case typ of
      0:begin
	copyblock(taille,ha,fond_pg,trunc(x),trunc(y),make_pg,trunc(x),trunc(y),true);
        x:=x_souris;
        if x>319-taille then begin
          x:=319-taille;
          souris_en_xy(x,y_souris);
        end;
      end;
      1:begin
	copyblock(taille,ha,fond_pg,trunc(x),trunc(y),make_pg,trunc(x),trunc(y),true);
        x:=x_souris;
        if x>319-taille then begin
          x:=319-taille;
          souris_en_xy(x,y_souris);
        end;
	if souris_bout=1 then for i:=1 to max_tirs do if not tir[i].inplay
	then if i<max_tirs then for j:=i+1 to max_tirs do if not tir[j].inplay then begin
	  tir[i].x:=x+5;
	  tir[i].y:=y;
	  tir[i].spe:=ball_spe;
	  tir[i].inplay:=true;
	  tir[j].x:=x+24;
	  tir[j].y:=y;
	  tir[j].spe:=ball_spe;
	  tir[j].inplay:=true;
	  i:=max_tirs;
	  j:=max_tirs;
	end;
      end;
      2:begin
	copyblock(taille,ha,fond_pg,trunc(x),trunc(y),make_pg,trunc(x),trunc(y),true);
	i:=x_souris;
	j:=y_souris;
	if i>319-taille then begin
          i:=319-taille;
          souris_en_xy(i,y_souris);
        end;
	if j>190 then j:=190;
        if j<10 then j:=10;
	if  (tab.brik[i div 20,j div 10]=0)
	and (tab.brik[(i+taille div 2) div 20,j div 10]=0)
	and (tab.brik[(i+taille-1) div 20,j div 10]=0)
	and (tab.brik[i div 20,(j+9) div 10]=0)
	and (tab.brik[(i+taille div 2) div 20,(j+9) div 10]=0)
	and (tab.brik[(i+taille-1) div 20,(j+9) div 10]=0) then begin
	  x:=i;
	  y:=j;
	end else souris_en_xy(x,y);
      end;
    end;
  end;
end;

procedure move_tirs;
begin
  for i:=1 to max_tirs do with tir[i] do if inplay then begin
    putpixel(make_pg,x,trunc(y),getpixel(x,trunc(y)));
    y:=y-spe;
    if y<10 then inplay:=false else begin
      putpixel(make_pg,x,trunc(y),col);
      if tab.brik[x div 20,trunc(y) div 10]<>0 then begin
	break_brik(x div 20,trunc(y) div 10);
        pong;
	inplay:=false;
      end;
    end;
  end;
end;

procedure move_options;
begin
  for i:=1 to max_options do with option[i] do if inplay then begin
    put_brik(x div 20,trunc(y) div 10);
    put_brik(x div 20,trunc(y+ha) div 10);
    y:=y+spe;
    if y>199-ha then inplay:=false else begin
      if (x+la>=raquette.x) and (x<=raquette.x+raquette.taille)
      and (y<=raquette.y+raquette.ha) and (y+ha+spe>=raquette.y) then begin
	inplay:=false;
        ding;
	with raquette do copyblock(taille,10,fond_pg,trunc(x),trunc(y),make_pg,trunc(x),trunc(y),true);
	case typ of
	  0..1:if life<99-typ then inc(life,typ+1);
	  2:if raquette.typ<>0 then begin
	      raquette.typ:=0;
	      raquette.y:=190;
	      raquette.taille:=20;
	      raquette.ha:=5;
	    end else if raquette.taille<245 then inc(raquette.taille,10) else raquette.taille:=255;
	  3:if raquette.typ<>0 then begin
	      raquette.typ:=0;
	      raquette.y:=190;
	      raquette.taille:=20;
	      raquette.ha:=5;
	    end else if raquette.taille>15 then dec(raquette.taille,10) else raquette.taille:=5;
	  4:if balls_left<max_balls then begin
	    inc(balls_left);
	    with balle[balls_left] do begin
	      typ:=random(3);
	      case typ of
		0:begin la:=5; ha:=5; spe:=ball_spe*2; end;
		1:begin la:=7; ha:=7; spe:=ball_spe; end;
		2:begin la:=9; ha:=9; spe:=ball_spe/2; end;
	      end;
	      ang:=220;
	      x:=raquette.x+(raquette.taille-la) div 2;
	      y:=raquette.y-ha;
	    end;
	  end;
	  5:dec(balls_left);
	  6:begin raquette.typ:=1; raquette.y:=190; raquette.taille:=30; raquette.ha:=8; end;
	  7:begin raquette.typ:=2; raquette.taille:=30; souris_en_xy(raquette.x,raquette.y); raquette.ha:=9; end;
	  8..11:inc(score,(typ-8)*100);
	end;
      end;
    end;
  end;
end;

procedure game_fini;
begin
  clearpage(scrn_pg);
  outtextxy(scrn_pg,139,97,'BRAVO !',col,false);
  repeat until souris_bout<>1;
  repeat until souris_bout=1;
  dec(niveau);
  best_score;
end;

procedure game_over;
begin
  clearpage(scrn_pg);
  outtextxy(scrn_pg,124,97,'GAME OVER...',col,false);
  repeat until souris_bout<>1;
  repeat until souris_bout=1;
  best_score;
end;

procedure show_tout;
begin
  str(score,s);
  outtextxy(make_pg,0,2,nom+' : '+s+'.',col,true);
  str(life-1,s);
  if life-1<10 then s:='0'+s;
  outtextxy(make_pg,100,2,'V : '+s+'.',col,true);
  str(niveau,s);
  outtextxy(make_pg,150,2,'L : '+s+'.',col,true);
  str(time,s);
  outtextxy(make_pg,200,2,'P : '+cod+'.',col,true);
  for cmpt:=1 to 5-length(s) do s:='0'+s;
  outtextxy(make_pg,260,2,'T : '+s+'.',col,true);
end;

procedure envoi;
begin
  if life=0 then game_over;
  repeat until souris_bout=1;
  repeat until souris_bout<>1;
  balls_left:=1;
  notime:=false;
  with raquette do begin
    typ:=0;
    taille:=20;
    ha:=5;
    x:=160-taille div 2;
    y:=190;
  end;
  for i:=0 to 15 do for j:=1 to 19 do put_brik(i,j);
  for i:=1 to max_options do option[i].inplay:=false;
  for i:=1 to max_tirs do tir[i].inplay:=false;
  time:=tab.time;
  show_tout;
  with balle[1] do begin
    repeat
      la:=7;
      ha:=7;
      typ:=1;
      copyblock(la,ha,fond_pg,raquette.x+(raquette.taille-la) div 2,raquette.y-ha,
      make_pg,raquette.x+(raquette.taille-la) div 2,raquette.y-ha,true);
      move_raquette;
      with raquette do begin
        copyblock(1,5,brik_pg,0,171,make_pg,trunc(x),trunc(y),false);
        copyblock(taille-2,5,brik_pg,1,171,make_pg,trunc(x)+1,trunc(y),true);
        copyblock(1,5,brik_pg,319,171,make_pg,trunc(x)+taille-1,trunc(y),false);
      end;
      put_ball(raquette.x+(raquette.taille-la) div 2,raquette.y-ha,typ);
      copypage(make_pg,scrn_pg);
    until souris_bout=1;
    repeat until souris_bout<>1;
    ang:=220;
    spe:=ball_spe;
    x:=raquette.x+(raquette.taille-la) div 2;
    y:=raquette.y-ha;
    debtime:=tab.time+heure*3600+minutes*60+secondes;
  end;
end;

procedure loadniv;
begin
  inc(niveau);
  str(niveau,s);
  if niveau<100 then s:='0'+s;
  if niveau<10 then s:='0'+s;
  {$i-}
  assign(fic,'niveaux\niveau.'+s);
  reset(fic);
  {$i+}
  if ioresult=0 then begin
    read(fic,tab);
    close(fic);
    briks_left:=0;
    for i:=0 to 15 do for j:=1 to 19 do if tab.brik[i,j] in [1..3,5..8,11..21] then inc(briks_left);
    freq_options:=tab.freq;
    clearpage(scrn_pg);
    outtextxy(scrn_pg,130,90,'NIVEAU '+s,col,false);
    outtextxy(scrn_pg,160-length(tab.nom)*3,100,tab.nom,col,false);
    cod:=niv2cod(niveau);
    outtextxy(scrn_pg,160-length(s)*3-33,110,'PASSWORD : '+cod,col,false);
    if nbimage<>0 then begin
      image:=(niveau-1) mod nbimage+1;
      str(image,s);
      if image<100 then s:='0'+s;
      if image<10 then s:='0'+s;
      loadpcx(paramstr(1)+'\data.'+s,fond_pg,40,216);
    end;
    repeat until souris_bout=1;
    repeat until souris_bout<>1;
  end else game_fini;
end;

procedure pause;
begin
  copyblock(90,15,brik_pg,0,185,scrn_pg,115,92,false);
  t:='';
  compt:=0;
  repeat until souris_bout<>2;
  while keypressed do cc:=readkey;
  repeat
    if keypressed then begin
      cc:=readkey;
      if cc=#0 then begin
        cc:=readkey;
        nt:=1000+ord(cc)
      end
      else nt:=ord(cc);
      case nt of
        8:if compt>0 then begin
          delete(t,compt,1);
	  dec(compt);
        end;
        13:begin
	  if t='CTIR' then with raquette do begin
            copyblock(taille,ha,fond_pg,trunc(x),trunc(y),make_pg,trunc(x),trunc(y),true);
            typ:=1; y:=190; taille:=30; ha:=8;
            ding;
          end;
	  if t='CVOL' then with raquette do begin
            copyblock(taille,ha,fond_pg,trunc(x),trunc(y),make_pg,trunc(x),trunc(y),true);
            typ:=2; taille:=30; ha:=9;
            ding;
          end;
          if (t='CVIE') and (life<99) then begin inc(life); ding; end;
          if t='CGOD' then begin life:=99; ding; end;
          if copy(t,1,4)='CWIN' then begin
            val(copy(t,5,3),cmpt,code);
            if cmpt<>0 then niveau:=cmpt-1;
            loadniv;
            clearpage(scrn_pg);
            outtextxy(scrn_pg,139,97,'READY ?',col,false);
            envoi;
            exit;
          end;
          if t='CCLK' then begin notime:=true; ding; end;
          if (t='CBAL') and (balls_left<max_balls) then begin
	    inc(balls_left);
	    with balle[balls_left] do begin
	      typ:=random(3);
	      case typ of
		0:begin la:=5; ha:=5; spe:=ball_spe*2; end;
		1:begin la:=7; ha:=7; spe:=ball_spe; end;
		2:begin la:=9; ha:=9; spe:=ball_spe/2; end;
	      end;
	      ang:=220;
	      x:=raquette.x+(raquette.taille-la) div 2;
	      y:=raquette.y-ha;
	    end;
            ding;
          end;
          t:='';
          compt:=0;
        end;
        32..255:begin
          inc(compt);
          insert(upcase(chr(nt)),t,compt);
        end;
      end;
    end;
  until souris_bout=2;
  repeat until souris_bout<>2;
  souris_en_xy(raquette.x,raquette.y);
  debtime:=time+heure*3600+minutes*60+secondes;
end;

begin
  init;
  life:=3;
  repeat
    if briks_left=0 then begin loadniv; clearpage(scrn_pg); outtextxy(scrn_pg,139,97,'READY ?',col,false); envoi; end;
    if not (notime) then time:=debtime-heure*3600-60*minutes-secondes;
    show_tout;
    if balls_left=0 then begin
      dec(life);
      clearpage(scrn_pg);
      outtextxy(scrn_pg,115,97,'PLUS DE BALLE !',col,false);
      envoi;
    end;
    for cmpt:=1 to balls_left do move_ball(balle[cmpt]);
    move_options;
    move_raquette;
    move_tirs;
    for cmpt:=1 to balls_left do put_ball(trunc(balle[cmpt].x),trunc(balle[cmpt].y),balle[cmpt].typ);
    for cmpt:=1 to max_options do with option[cmpt] do
    if inplay then case typ of
      0:copyblock(la,ha,brik_pg,21,160,make_pg,x,trunc(y),false);
      1:copyblock(la,ha,brik_pg,21,165,make_pg,x,trunc(y),false);
      2:copyblock(la,ha,brik_pg,34,160,make_pg,x,trunc(y),false);
      3:copyblock(la,ha,brik_pg,34,165,make_pg,x,trunc(y),false);
      4:copyblock(la,ha,brik_pg,45,160,make_pg,x,trunc(y),false);
      5:copyblock(la,ha,brik_pg,45,164,make_pg,x,trunc(y),false);
      6:copyblock(la,ha,brik_pg,50,160,make_pg,x,trunc(y),false);
      7:copyblock(la,ha,brik_pg,50,165,make_pg,x,trunc(y),false);
      8:copyblock(la,ha,brik_pg,59,160,make_pg,x,trunc(y),false);
      9:copyblock(la,ha,brik_pg,59,165,make_pg,x,trunc(y),false);
      10:copyblock(la,ha,brik_pg,71,160,make_pg,x,trunc(y),false);
      11:copyblock(la,ha,brik_pg,71,165,make_pg,x,trunc(y),false);
    end;
    with raquette do case typ of
      0:begin
	copyblock(1,5,brik_pg,0,171,make_pg,trunc(x),trunc(y),false);
	copyblock(taille-2,5,brik_pg,1,171,make_pg,trunc(x)+1,trunc(y),true);
	copyblock(1,5,brik_pg,319,171,make_pg,trunc(x)+taille-1,trunc(y),false);
      end;
      1:copyblock(taille,8,brik_pg,0,176,make_pg,trunc(x),trunc(y),false);
      2:copyblock(taille,9,brik_pg,30,176,make_pg,trunc(x),trunc(y),false);
    end;
    if souris_bout=2 then pause;
    copypage(make_pg,scrn_pg);
    if time<=0 then begin dec(life); clearpage(scrn_pg); outtextxy(scrn_pg,133,97,'TIME UP !',col,false); envoi; end;
  until port[$60]=1;
  repeat until souris_bout=0;
  best_score;
end.

