
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1998][royale@ifrance.com]ͼ
                --  :*)

unit sourunit;

INTERFACE
function existe_souris:boolean;
function x_souris:word;
function y_souris:word;
function souris_bout:byte;
procedure init_souris;
procedure sens_souris(x,y:word);
procedure limit_souris(xmin,xmax,ymin,ymax:word);
procedure souris_on;
procedure souris_off;
procedure souris_en_xy(x,y:word);


IMPLEMENTATION

function existe_souris:boolean; assembler;
asm
  xor ax,ax
  int 33h
  cmp ax,-1
  je @skip
  xor al,al
  @skip:
end;

procedure sens_souris(x,y:word); assembler;
asm
  mov ax,1ah
  mov bx,x
  mov cx,y
  xor dx,dx
  int 33h
end;

procedure limit_souris(xmin,xmax,ymin,ymax:word); assembler;
asm
  mov ax,7
  mov cx,xmin
  mov dx,xmax
  int 33h
  mov ax,8
  mov cx,ymin
  mov dx,ymax
  int 33h
end;

procedure init_souris; assembler;
asm
  mov ax,00h
  int 33h
end;

procedure souris_on; assembler;
asm
  mov ax,01h
  int 33h
end;

procedure souris_off; assembler;
asm
  mov ax,02h
  int 33h
end;

procedure souris_en_xy(x,y:word); assembler;
asm
  mov ax,04h
  mov cx,x
  mov dx,y
  int 33h
end;

function x_souris:word; assembler;
asm
  mov ax,03h
  int 33h
  mov ax,cx
end;

function y_souris:word; assembler;
asm
  mov ax,03h
  int 33h
  mov ax,dx
end;

function souris_bout:byte; assembler;
asm
  mov ax,3
  int 33h
  mov ax,bx
end;

end.