
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1998][royale@ifrance.com]ͼ
                --  :*)

program edit_niv;

uses crt,sourunit;

const scrn_pg=ptr($A000,0);
{$i police.inc}
{$i pcx.inc}
type niv=record
	   nom:string[50];
           time:integer;
           freq:byte;
	   brik:array [0..15,1..19] of byte;
	 end;

var fond_pg,brik_pg:pointer;   {pointeurs de pages virtuelles.}
    i,j:word;
    tab:niv;
    xs,ys:word;
    fic:file of niv;
    pp,actuel:byte;
    s:string;
    stop:boolean;
    cc:char;

procedure init_mode13;               {initialise le mode 13.}
begin
  getmem(fond_pg,64000);
  getmem(brik_pg,64000);
  asm
    mov ax,13h
    int 10h
  end;
end;

procedure close_mode13;              {ferme le mode 13 et les pointers.}
var i:word;
begin
  freemem(fond_pg,64000);
  freemem(brik_pg,64000);
  asm
    mov ax,03h
    int 10h
  end;
end;

procedure copypage(source,dest:pointer); assembler;
asm
  push ds
  les di,dest
  lds si,source
  mov cx,320*200/4
  db 66h;rep movsw
  pop ds
end;

procedure clearpage(page:pointer); assembler;
asm
  les di,page
  mov cx,320*200/4
  db 66h;xor ax,ax
  db 66h;rep stosw
end;

procedure copyblock(x,y:word; source:pointer; xs,ys:word; dest:pointer; xd,yd:word; mask:boolean); assembler;
asm
  push ds

  cmp x,0
  je @fin
  cmp y,0
  je @fin

  lds si,source
  les di,dest

  mov ax,yd
  shl ax,6
  add di,ax
  shl ax,2
  add di,ax
  add di,xd

  mov ax,ys
  shl ax,6
  add si,ax
  shl ax,2
  add si,ax
  add si,xs

  mov bx,320
  sub bx,x                  {met dans bx le dcalage de fin de ligne.}
  mov cx,y                  {met dans le compteur cx la largeur y.}

  cmp mask,false            {si masque est faux, on saute  la sous-procedure}
  je @sprite                {putsprite...}

  @boucle:
    push cx
    mov cx,x
    mov dx,cx
    shr cx,2
    db 66h;rep movsw
    mov cx,dx
    and cx,3
    rep movsb
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @boucle
  jmp @fin

  @sprite:
    push cx
    mov cx,x
    @line:
      mov ah,ds:[si]
      or ah,ah
      je @noir
      mov es:[di],ah
      @noir:
      inc di
      inc si
      dec cx
    jnz @line
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @sprite

  @fin:
  pop ds
end;

procedure put_brik(i,j:byte);
begin
  tab.brik[i,j]:=actuel;
  if actuel=0 then copyblock(20,10,fond_pg,0,0,scrn_pg,i*20,j*10,true)
  else copyblock(20,10,brik_pg,((actuel-1) mod 16)*20,(actuel-1) div 16*10,scrn_pg,i*20,j*10,true);
end;

begin
  init_mode13;
  if not existe_souris then halt;
  sens_souris(20,20);
  souris_en_xy(160,100);
  loadpcx('briks.pcx',brik_pg,0,40);
  clearpage(fond_pg);
  clearpage(scrn_pg);
  tab.nom:=saisir(0,0,'NOM DU NIVEAU ? ',38);
  val(saisir(0,10,'TEMPS ? ',38),tab.time,i);
  val(saisir(0,20,'FREQUENCE OPTIONS ? ',38),tab.freq,i);
  clearpage(scrn_pg);
  souris_on;
  copyblock(20,10,brik_pg,160,0,scrn_pg,300,0,true);
  copyblock(20,10,brik_pg,180,0,scrn_pg,0,0,true);
  for i:=0 to 11 do
  if pp*12+i=0 then copyblock(20,10,fond_pg,0,0,scrn_pg,40,0,true) else
  copyblock(20,10,brik_pg,((pp*12+i-1) mod 16)*20,(pp*12+i-1) div 16*10,scrn_pg,i*20+40,0,true);
  str(actuel,s);
  if actuel<100 then s:='0'+s;
  if actuel<10 then s:='0'+s;
  outtextxy(scrn_pg,21,2,s,40);
  repeat
    xs:=x_souris div 2;
    ys:=y_souris;
    if souris_bout=1 then if ys<180 then
    if ys>10 then begin
      souris_off;
      put_brik(xs div 20,ys div 10);
      souris_on;
    end else begin
      if (xs>300) and (pp<20) then inc(pp);
      if (xs<20) and (pp>0) then dec(pp);
      for i:=0 to 11 do
      if pp*12+i=0 then copyblock(20,10,fond_pg,0,0,scrn_pg,40,0,true) else
      copyblock(20,10,brik_pg,((pp*12+i-1) mod 16)*20,(pp*12+i-1) div 16*10,scrn_pg,i*20+40,0,true);
      if (xs>40) and (xs<280) then actuel:=pp*12+xs div 20-2;
      str(actuel,s);
      if actuel<100 then s:='0'+s;
      if actuel<10 then s:='0'+s;
      outtextxy(scrn_pg,21,2,s,40);
      repeat until souris_bout<>1;
    end;
    if souris_bout=2 then begin
      {$i-}
      i:=0;
      repeat
        inc(i);
        str(i,s);
        if i<100 then s:='0'+s;
        if i<10 then s:='0'+s;
        assign(fic,'niveaux/niveau.'+s);
        reset(fic);
        if ioresult<>0 then stop:=true else close(fic);
      until stop;
      {$i+}
      rewrite(fic);
      write(fic,tab);
      close(fic);
    end;
  until stop or (port[$60]=1);
  close_mode13;
end.